<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/
  class ot_coupon {
	var $title, $output;

	function ot_coupon() {
	  $this->code = 'ot_coupon';
	  $this->title = 'Coupons';
	  $this->description = 'Discount Coupon Options:';
	  $this->enabled = defined('MODULE_ORDER_TOTAL_COUPON_STATUS');
	  $this->sort_order = 2;

	  $this->output = array();
	}

	function process() {
	  global $order, $shipping_cost;
	  if (!@$_SESSION['cart']->coupons) return true;
	    $order->coupons = $_SESSION['cart']->coupons;
	    if (!$order->coupons) return false;
	    $order_total_used = false;
	    $free_shipping_used = false;
	    $total_coupons = 0;

	    foreach ($order->coupons as $key => $value) {
	      $coupon = shop_db_fetch_array(shop_db_query("select * from " . DB_PREFIX . "coupons where coupons_code = '$key' and (expires_date >= now() or expires_date = '00-00-0000 00:00:00')"));
	      $customer = shop_db_fetch_array(shop_db_query("select * from " . DB_PREFIX . "coupons_to_customers where coupons_id = '" . $coupon['coupons_id'] . "' and customers_id = '" . $_SESSION['customer_id'] . "'"));
	      if (($coupon['max_usage'] != 0) && ($coupon['max_usage'] <= $customer['coupon_usage'])) continue;
	      if ($order->info['total'] < $coupon['over_amount']) continue;
	      switch ($coupon['coupon_type']) {
	        case '1':
	          foreach ($order->products as $pkey => $pvalue) {
	            if ($pvalue['id'] == $coupon['products_id']) {
	              if (strstr($coupon['amount'], '%')) {
	                $amount = $order->products[$pkey]['qty'] * ($order->products[$pkey]['final_price'] * ("0." . substr($coupon['amount'],0,-1)));
	              } else {
	                $amount = $order->products[$pkey]['qty'] * $coupon['amount'];
	              }
	              $order->products[$pkey]['final_price'] -= $amount;
	            }
	          }
	          if (MODULE_ORDER_TOTAL_COUPON_GROUPS == 'true') {
	            $this->output[] = array('title' => 'Coupon (' . $key . '):',
	                                    'text' => '-' . $GLOBALS['currencies']->format($amount),
	                                    'value' => $amount);
	          }
	          $total_coupons += $amount;
	          break;
	        case '2':
	          $amount = 0;
	          foreach ($order->products as $pkey => $pvalue) {
	            $categories = shop_db_fetch_array(shop_db_query("select products_id from " . DB_PREFIX . "products_to_categories where products_id = '" . $pvalue['id'] . "' and categories_id = '" . $coupon['categories_id'] . "'"));
	            if ($categories['products_id'] == $pvalue['id']) {
	              if (strstr($coupon['amount'], '%')) {
	                $one_amount = $order->products[$pkey]['final_price'] * ("0." . substr($coupon['amount'],0,-1));
	              } else {
	                $one_amount = $coupon['amount'];
	              }
	              $amount += $one_amount * $order->products[$pkey]['qty'];
	              $order->products[$pkey]['final_price'] -= $one_amount;
	            }
	          }
	        
	          if (MODULE_ORDER_TOTAL_COUPON_GROUPS == 'true') {
	            $this->output[] = array('title' => 'Coupon (' . $key . '):',
	                                    'text' => '-' . $GLOBALS['currencies']->format($amount),
	                                    'value' => $amount);
	          }
	          $total_coupons += $amount;
	          break;
	        case '3':
	          $amount = 0;
	          foreach ($order->products as $pkey => $pvalue) {
	            $manufacturers = shop_db_fetch_array(shop_db_query("select products_id as count from " . DB_PREFIX . "products where products_id = '" . $pvalue['id'] . "' and manufacturers_id = '" . $coupon['manufacturers_id'] . "'"));
	            if ($manufacturers['products_id']) {
	              if (strstr($coupon['amount'], '%')) {
	                $one_amount = $order->products[$pkey]['final_price'] * ("0." . substr($coupon['amount'],0,-1));
	              } else {
	                $one_amount = $coupon['amount'];
	              }
	              $amount += $one_amount * $order->products[$pkey]['qty'];
	            }
	          }
	        
	          if (MODULE_ORDER_TOTAL_COUPON_GROUPS == 'true') {
	            $this->output[] = array('title' => 'Coupon (' . $key . '):',
	                                    'text' => '-' . $GLOBALS['currencies']->format($amount),
	                                    'value' => $amount);
	          }
	          $total_coupons += $amount;
	          break;
	        case '4':
	          if (!@$order_total_used) {
	            if (strstr($coupon['amount'], '%')) {
	              $amount = $order->info['subtotal'] * ("0." . substr($coupon['amount'],0,-1));
	            } else {
	              $amount = $coupon['amount'];
	            }
	        
	            if (MODULE_ORDER_TOTAL_COUPON_GROUPS == 'true') {
	              $this->output[] = array('title' => 'Coupon (' . $key . '):',
	                                      'text' => '-' . $GLOBALS['currencies']->format($amount),
	                                      'value' => $amount);
	            }
	            $order_total_used = true;
	            $total_coupons += $amount;
	          }
	          break;
	        case '5':
	          if (!@$free_shipping_used) {
	            $shipping_cost = 0;
	            define(MODULE_ORDER_COUPON_FREESHIP, 'true');
	        	
	        	unset($order->info['shipping']);
	        	unset($order->info['shipping_cost']);
	        	
	            if (MODULE_ORDER_TOTAL_COUPON_GROUPS == 'true') {
	              $this->output[] = array('title' => 'Coupon (' . $key . '):',
	                                      'text' => 'Free Ship.',
	                                      'value' => $order->info['shipping_cost']);
	            }
	            $free_shipping_used = true;
	          }
	          break;
	      }
	    }
	    
	    if ($total_coupons != 0) {
	        $order->info['coupons'] = "-" . $total_coupons;
	        $order->info['total'] -= $total_coupons;

	        if (MODULE_ORDER_TOTAL_COUPON_GROUPS != 'true') {
	          $this->output[] = array('title' => 'Coupons:',
	                                  'text' => '-' . $GLOBALS['currencies']->format($total_coupons),
	                                  'value' => '-' . $total_coupons);
	        }
	    }
	}

	function check() {
	  return defined('MODULE_ORDER_TOTAL_COUPON_STATUS');
	}

	function keys() {
	  return array('MODULE_ORDER_TOTAL_COUPON_STATUS', 'MODULE_ORDER_TOTAL_COUPON_GROUPS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_ORDER_TOTAL_COUPON_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Display Coupon Groups', 'MODULE_ORDER_TOTAL_COUPON_GROUPS', 'false', 'Display coupon groups at checkout?', 6, 1, 'shop_cfg_checkbox_display(', 'shop_cfg_checkbox(', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_ORDER_TOTAL_COUPON_%'");
	}
  }
