<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  class ot_shipping {
	var $title, $output;

	function ot_shipping() {
	  $this->code = 'ot_shipping';
	  $this->title = MODULE_ORDER_TOTAL_SHIPPING_TITLE;
	  $this->description = 'Shipping Options:';
	  $this->enabled = defined('MODULE_ORDER_TOTAL_SHIPPING_STATUS');
	  $this->sort_order = 3;

	  $this->output = array();
	}

	function process() {
	  global $order, $shipping_cost;
	  // If free shipping module is enabled or coupon for freeshipping
	  if (MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING == 'true' || defined('MODULE_ORDER_COUPON_FREESHIP')) {
	    switch (MODULE_ORDER_TOTAL_SHIPPING_DESTINATION) {
	      case 'national':
	        if ($order->delivery['country_id'] == STORE_COUNTRY_ID) $pass = true; break;
	      case 'both':
	      case 'international':
	        $pass = true; break;
	      default:
	        $pass = false; break;
	    }
			// if free shipping coupon OR pass is true and subtotal >= free amount
	    if (MODULE_ORDER_COUPON_FREESHIP == 'true' || (($pass == true && ($order->info['total'] - $order->info['shipping_cost']) >= MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER))) {
	      $order->info['shipping_method'] = $this->title;
	      $order->info['total'] -= $order->info['shipping_cost'];
	      $order->info['shipping_cost'] = 0;
	      $shipping_cost = 0;
	    }
	  }
		if ($order->info['shipping_method'] && $pass == false) {
			if (MODULE_ORDER_TOTAL_SHIPPING_TAX_CLASS > 0) {
				$shipping_tax = shop_get_tax_rate(MODULE_ORDER_TOTAL_SHIPPING_TAX_CLASS);

				$order->info['tax'] += shop_calculate_tax($order->info['shipping_cost'], $shipping_tax);
				$order->info['tax_groups']["{$shipping_tax}"] += shop_calculate_tax($order->info['shipping_cost'], $shipping_tax);
				$order->info['total'] += shop_calculate_tax($order->info['shipping_cost'], $shipping_tax);
				$order->info['shipping_cost'] += shop_calculate_tax($order->info['shipping_cost'], $shipping_tax);
			}
		}

		if (MYSELF == 'shopping_cart.php') return false;
		if ($order->info['shipping_method'] == '') $order->info['shipping_method'] = MODULE_ORDER_TOTAL_SHIPPING_TITLE;
		$this->output[] = array('title' => $order->info['shipping_method'] . ':',
														'text' => $GLOBALS['currencies']->format($order->info['shipping_cost'], true, $order->info['currency'], $order->info['currency_value']),
														'value' => $order->info['shipping_cost']);
	}

	function check() {
	  return defined('MODULE_ORDER_TOTAL_SHIPPING_STATUS');
	}

	function keys() {
	  return array('MODULE_ORDER_TOTAL_SHIPPING_STATUS', 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING', 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER', 'MODULE_ORDER_TOTAL_SHIPPING_DESTINATION', 'MODULE_ORDER_TOTAL_SHIPPING_TAX_CLASS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_ORDER_TOTAL_SHIPPING_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Allow Free Shipping', 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING', 'false', 'Allow free shipping?', '6', '1', 'shop_cfg_checkbox_display(', 'shop_cfg_checkbox(', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, date_added) values ('Free Shipping For Orders Over', 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER', '50', 'Provide free shipping for orders over the set amount.', '6', '2', 'shop_cfg_price_display(', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Provide Free Shipping For Orders Made', 'MODULE_ORDER_TOTAL_SHIPPING_DESTINATION', 'national', 'Provide free shipping for orders sent to the following destination.', '6', '3', 'shop_cfg_select_option(array(\'national\', \'international\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_ORDER_TOTAL_SHIPPING_TAX_CLASS', '0', 'Use the following tax class on the shipping fee.', '6', '4', 'shop_get_tax_class_title', 'shop_cfg_pull_down_tax_classes(', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("','", $this->keys()) . "')");
	}
  }
