<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/
  
  class eselect {
	var $code, $title, $description, $enabled;

	function eselect() {
	  $this->code = 'eselect';
	  $this->title = 'Moneris eSelect';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'http://www.moneris.com/';
	  $this->enabled = defined('MODULE_PAYMENT_ESELECT_STATUS');
	  $this->recommend_level = 4;
	  $this->version = "1.1";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	  global $checkout_form_action;

	  if (MODULE_PAYMENT_ESELECT_TESTMODE == 'Test') {
	      $https_host = 'esqa.moneris.com';
	  } else {
	      $https_host = 'www3.moneris.com';
	  }

	  $checkout_form_action = 'https://' . $https_host . '/hosted/index.php';

	  return false;
	}

	function process_button() {
	  global  $order;

	  $process_button_string = shop_draw_hidden_field('store_id', MODULE_PAYMENT_ESELECT_STORE_ID) . UNIX_RETURN .
	                           shop_draw_hidden_field('post_receipt', '1') . UNIX_RETURN .
	                           shop_draw_hidden_field('api_token', MODULE_PAYMENT_ESELECT_API_TOKEN) . UNIX_RETURN .
	                           shop_draw_hidden_field('receipt_URL', shop_href_link('checkout_payment.php', '', 'SSL')) . UNIX_RETURN .
	                           shop_draw_hidden_field('return_URL', shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR), 'SSL')) . UNIX_RETURN .
	                           shop_draw_hidden_field('charge_total', number_format($order->info['total'] * $GLOBALS['currencies']->get_value('CAD'), 2)) . UNIX_RETURN .
	                           shop_draw_hidden_field('Cardholder', $_POST['cc_owner']) . UNIX_RETURN .
	                           shop_draw_hidden_field('credit_card_number', $_POST['cc_number']) . UNIX_RETURN .
	                           shop_draw_hidden_field('expiry_date', $_POST['cc_expires_month'] . substr($_POST['cc_expires_year'],-2)) . UNIX_RETURN .
	                           shop_draw_hidden_field('DateExpires', $_POST['cc_expires_month'] . substr($_POST['cc_expires_year'],-2)) . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_first_name', $order->customer['firstname']) . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_last_name', $order->customer['lastname']) . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_address_one', $order->customer['street_address']) . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_city', $order->customer['city']) . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_state', $order->customer['state']) . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_postal_code', $order->customer['postcode']) . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_country', $order->customer['country']) . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_phone', $order->customer['telephone']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ship_first_name', $order->delivery['firstname']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ship_last_name', $order->delivery['lastname']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ship_address_one', $order->delivery['street_address']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ship_city', $order->delivery['city']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ship_state', $order->delivery['state']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ship_postal_code', $order->delivery['postcode']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ship_country', $order->delivery['country']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ship_phone', $order->customer['telephone']) . UNIX_RETURN .
	                           shop_draw_hidden_field('email', $order->customer['email_address']) . UNIX_RETURN .
	                           shop_draw_hidden_field('doTrans', 'Process') . UNIX_RETURN .
	                           shop_draw_hidden_field('bill_email', $order->customer['email_address']) . UNIX_RETURN .
	                           shop_draw_hidden_field('mail_client','1') . UNIX_RETURN;
	                           
	  return $process_button_string;
	}

	function before_process() {
	  if ($_POST['result'] != '1') {
		shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR . ' ' . $_POST['message']), 'SSL'));
	  }
	  $order->info['cc_approval'] = $_POST['bank_approval_code'];
	}

	function after_process() {
	  return false;
	}

	function check() {
	  return defined('MODULE_PAYMENT_ESELECT_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_ESELECT_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('eSelect Store ID', 'MODULE_PAYMENT_ESELECT_STORE_ID', 'store1', '', '6', '2', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('eSelect API Token', 'MODULE_PAYMENT_ESELECT_API_TOKEN', 'yesguy', '', '6', '2', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_ESELECT_TESTMODE', 'Test', 'Transaction mode used for processing orders', '6', '0', 'shop_cfg_select_option(array(\'Test\', \'Production\'), ', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("','", $this->keys()) . "')");
	}

	function keys() {
	  return array('MODULE_PAYMENT_ESELECT_STATUS', 'MODULE_PAYMENT_ESELECT_STORE_ID', 'MODULE_PAYMENT_ESELECT_API_TOKEN', 'MODULE_PAYMENT_ESELECT_TESTMODE');
	}
  }
