<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  class payflow_link {
	var $code, $title, $description, $enabled;

	function payflow_link() {
	  $this->code = 'payflow_link';
	  $this->title = 'Verisign Payflow Link';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'http://www.verisign.com/products/payflow/link/';
	  $this->enabled = defined('MODULE_PAYMENT_PAYFLOW_LINK_STATUS');
	  $this->recommend_level = 5;
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	  global $checkout_form_action;

	  #$checkout_form_action = 'https://payflowlink.verisign.com/payflowlink.cfm';
	  $checkout_form_action = 'https://payments.verisign.com/payflowlink';
	  
	  return false;
	}

	function process_button() {
	  global $order;

	  $process_button_string = shop_draw_hidden_field('login', MODULE_PAYMENT_PAYFLOW_LINK_LOGIN) . UNIX_RETURN .
							   shop_draw_hidden_field('partner', MODULE_PAYMENT_PAYFLOW_LINK_PARTNER) . UNIX_RETURN .
							   shop_draw_hidden_field('type', 'S') . UNIX_RETURN .
							   shop_draw_hidden_field('returnurl', shop_href_link('checkout_process.php', SESSION_SID, 'SSL')) . UNIX_RETURN .
							   shop_draw_hidden_field('failedurl', shop_href_link('checkout_payment.php', SESSION_SID, 'SSL')) . UNIX_RETURN .
							   shop_draw_hidden_field('buttontext', "Complete Order") . UNIX_RETURN .
							   shop_draw_hidden_field('method', 'cc') . UNIX_RETURN .
							   shop_draw_hidden_field('disablereceipt', 'true') . UNIX_RETURN .
							   shop_draw_hidden_field('echodata', 'false') . UNIX_RETURN .
							   shop_draw_hidden_field('showconfirm', 'false') . UNIX_RETURN .
							   shop_draw_hidden_field('orderform', 'false') . UNIX_RETURN .
							   shop_draw_hidden_field('emailcustomer', 'false') . UNIX_RETURN .
							   shop_draw_hidden_field('name', $_POST['cc_owner']) . UNIX_RETURN .
							   shop_draw_hidden_field('cardnum', $_POST['cc_number']) . UNIX_RETURN .
							   shop_draw_hidden_field('expdate', $_POST['cc_expires_month'] . substr($_POST['cc_expires_year'],-2)) . UNIX_RETURN .
							   shop_draw_hidden_field('csc', $_POST['cc_code']) . UNIX_RETURN .
							   shop_draw_hidden_field('amount', number_format($order->info['total'],2)) . UNIX_RETURN .
							   shop_draw_hidden_field('address', $order->customer['street_address']) . UNIX_RETURN .
							   shop_draw_hidden_field('city', $order->customer['city']) . UNIX_RETURN .
							   shop_draw_hidden_field('state', $order->customer['state']) . UNIX_RETURN .
							   shop_draw_hidden_field('zip', $order->customer['postcode']) . UNIX_RETURN .
							   shop_draw_hidden_field('country', $order->customer['country']) . UNIX_RETURN .
							   shop_draw_hidden_field('phone', $order->customer['telephone']) . UNIX_RETURN .
							   shop_draw_hidden_field('email', $order->customer['email_address']) . UNIX_RETURN .
							   shop_draw_hidden_field('nametoship', $order->delivery['firstname'] . ' ' . $order->delivery['lastname']) . UNIX_RETURN .
							   shop_draw_hidden_field('addresstoship', $order->delivery['street_address']) . UNIX_RETURN .
							   shop_draw_hidden_field('citytoship', $order->delivery['city']) . UNIX_RETURN .
							   shop_draw_hidden_field('statetoship', $order->delivery['state']) . UNIX_RETURN .
							   shop_draw_hidden_field('ziptoship', $order->delivery['postcode']) . UNIX_RETURN .
							   shop_draw_hidden_field('countrytoship', $order->delivery['country']) . UNIX_RETURN;

	  return $process_button_string;
	}

	function before_process() {
	  if ($_GET['RESPMSG'] != 'Approved') {
		shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR), 'SSL'));
	  }
	  $order->info['cc_approval'] = $_GET['AUTHCODE'];
	}

	function after_process() {
	  return false;
	}

	function check() {
	  return defined('MODULE_PAYMENT_PAYFLOW_LINK_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_PAYFLOW_LINK_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Login ID', 'MODULE_PAYMENT_PAYFLOW_LINK_LOGIN', 'Tester', 'Your VeriSign Login ID.', '6', '1', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Partner ID', 'MODULE_PAYMENT_PAYFLOW_LINK_PARTNER', 'VeriSign', 'Your VeriSign Partner ID.', '6', '2', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_PAYFLOW_LINK_%'");
	}

	function keys() {
	  $keys = array('MODULE_PAYMENT_PAYFLOW_LINK_STATUS', 'MODULE_PAYMENT_PAYFLOW_LINK_LOGIN', 'MODULE_PAYMENT_PAYFLOW_LINK_PARTNER');

	  return $keys;
	}
  }