<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

class regional_rate {
	var $code, $title, $description, $icon, $enabled, $quote;

	function regional_rate() {
		$this->code = 'regional_rate';
		$this->title = 'Regional Rate';
		$this->description = 'Regional Rate Shipping Options:';
		$this->icon = 'images/shipping/shipping.gif';
		$this->enabled = defined('MODULE_SHIPPING_REGIONAL_STATUS');
		$this->quote = array();
	}

	function quote() {
		global $address_values;

		if ($address_values['country_id'] == STORE_COUNTRY_ID) {
			$rate_table = MODULE_SHIPPING_REGIONAL_LOCAL_COST;
		} elseif ($address_values['continent'] == 1) {
			$rate_table = MODULE_SHIPPING_REGIONAL_AFRICA_COST;
		} elseif ($address_values['continent'] == 2) {
			$rate_table = MODULE_SHIPPING_REGIONAL_ASIA_COST;
		} elseif ($address_values['continent'] == 3) {
			$rate_table = MODULE_SHIPPING_REGIONAL_EUROPE_COST;
		} elseif ($address_values['continent'] == 4) {
			$rate_table = MODULE_SHIPPING_REGIONAL_NAMERICA_COST;
		} elseif ($address_values['continent'] == 5) {
			$rate_table = MODULE_SHIPPING_REGIONAL_OCEANIA_COST;
		} elseif ($address_values['continent'] == 6) {
			$rate_table = MODULE_SHIPPING_REGIONAL_SAMERICA_COST;
		}

		if (MODULE_SHIPPING_REGIONAL_MODE == 'price') {
			$order_total = $_SESSION['cart']->show_total();
		} else {
			$order_total = $_SESSION['cart']->show_weight();
		}

		$table_cost = split("[:;]" , $rate_table);
		for ($i = 0; $i < count($table_cost); $i++) {
			$j=$i*2;
			if ($order_total <= $table_cost[$j]) {
				$total = $table_cost[$j+1];
				break;
			}
		}
		
		if ($total > 0) {
			$total = $total + ($total * (SHIPPING_MARK/100));
			$total = (SHIPPING_HANDLING_TOTAL + $total);
			$this->quote[] = array('Method' => MODULE_SHIPPING_TABLE_TEXT_WAY, 'Service' => MODULE_SHIPPING_REGIONAL_NAME, 'TotalCharges' => $total);

			return $total;
		}
	}

	function check() {
	  return defined('MODULE_SHIPPING_REGIONAL_STATUS');
	}

	function install() {
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_SHIPPING_REGIONAL_STATUS', 'true')");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Name of regional shipping option', 'MODULE_SHIPPING_REGIONAL_NAME', 'Regional Rate Shipping', 'The name of the table rate shipping option:', '6', '1', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shipping Table (Local)', 'MODULE_SHIPPING_REGIONAL_LOCAL_COST', '25:8.50;50:5.50;10000:0.00', 'Example table: 25:8.50;50:5.50 - up to 25 ($/lbs) charge $8.50, from there to 50 charge $5.50.', '6', '2', 'shop_cfg_textarea(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shipping Table (Africa)', 'MODULE_SHIPPING_REGIONAL_AFRICA_COST', '25:8.50;50:5.50;10000:0.00', '', '6', '3', 'shop_cfg_textarea(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shipping Table (Asia)', 'MODULE_SHIPPING_REGIONAL_ASIA_COST', '25:8.50;50:5.50;10000:0.00', '', '6', '4', 'shop_cfg_textarea(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shipping Table (Europe)', 'MODULE_SHIPPING_REGIONAL_EUROPE_COST', '25:8.50;50:5.50;10000:0.00', '', '6', '5', 'shop_cfg_textarea(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shipping Table (North America)', 'MODULE_SHIPPING_REGIONAL_NAMERICA_COST', '25:8.50;50:5.50;10000:0.00', '', '6', '6', 'shop_cfg_textarea(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shipping Table (Oceania)', 'MODULE_SHIPPING_REGIONAL_OCEANIA_COST', '25:8.50;50:5.50;10000:0.00', '', '6', '7', 'shop_cfg_textarea(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shipping Table (South America)', 'MODULE_SHIPPING_REGIONAL_SAMERICA_COST', '25:8.50;50:5.50;10000:0.00', '', '6', '8', 'shop_cfg_textarea(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Regional Method', 'MODULE_SHIPPING_REGIONAL_MODE', 'weight', 'Are the shipping tables based on the total weight or the total amount of the order?', '6', '9', 'shop_cfg_select_option(array(\'weight\', \'price\'), ', now())");
	}

	function remove() {
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_SHIPPING_REGIONAL_%'");
	}

	function keys() {
		return array('MODULE_SHIPPING_REGIONAL_STATUS', 'MODULE_SHIPPING_REGIONAL_NAME', 'MODULE_SHIPPING_REGIONAL_LOCAL_COST', 'MODULE_SHIPPING_REGIONAL_AFRICA_COST', 'MODULE_SHIPPING_REGIONAL_ASIA_COST', 'MODULE_SHIPPING_REGIONAL_EUROPE_COST', 'MODULE_SHIPPING_REGIONAL_NAMERICA_COST', 'MODULE_SHIPPING_REGIONAL_OCEANIA_COST', 'MODULE_SHIPPING_REGIONAL_SAMERICA_COST', 'MODULE_SHIPPING_REGIONAL_MODE');
	}
}
