<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003-04, Secure.cc, Inc.
*/

class ups {
	var $code;
	var $title;
	var $description;
	var $icon;
	var $enabled;
	var $recommend_level;
	var $version; 
	var $quote;

	function ups() {
		$this->code = 'ups';
		$this->title = 'UPS OnLine Tools';
		$this->shop_title = 'UPS';
		$this->description = 'UPS OnLine Tools Rates &amp; Services';
		$this->icon = 'images/shipping/shipping.gif';
		$this->enabled = defined('MODULE_SHIPPING_UPS_STATUS');
		$this->recommend_level = 5;
		$this->version = "3.0z";
		$this->quote = array();
	}

	function quote() {
		global $shipping_weight, $shipping_num_boxes, $address_values;

		// Get enabled shipping methods
		$keys = $this->keys();
		foreach ($keys as $key => $type) {
			if ($type != 'MODULE_SHIPPING_UPS_STATUS' &&
				  $type != 'MODULE_SHIPPING_UPS_RESCOM' && 
				  $type != 'MODULE_SHIPPING_UPS_CONT' && 
				  $type != 'MODULE_SHIPPING_UPS_RATE' && 
				  $type != 'MODULE_SHIPPING_UPS_NOQUOTE' && constant($type) == 'true') {
				$enabled[] = str_replace('MODULE_SHIPPING_UPS_', '', $type);
			}
		}

    if (count($enabled)==1) {
    	$prod = $method;
    	$action = 3; // single quote
    }
    else if ($address_values['country_code'] == 'CA') $prod = 'STD';
    else $prod = 'GNDRES';

    if (!$action) $action = 4; // multiple quotes
    
    $residential = MODULE_SHIPPING_UPS_RESCOM == 'Residential' ? '1' : '0';
    $rate = @urlencode(MODULE_SHIPPING_UPS_RATE);
    $dest_postal = preg_replace("/([^0-9A-Za-z])/","", $address_values['postcode']);

		switch (MODULE_SHIPPING_UPS_CONT) {
      case 'Customer Packaging': $container = '00'; break;
      case 'UPS Letter Envelope': $container = '01'; break;
      case 'UPS Tube': $container = '03'; break;
      case 'UPS Express Box': $container = '21'; break;
      case 'UPS Worldwide 25 kilo': $container = '24'; break;
      case 'UPS Worldwide 10 kilo': $container = '25'; break;
    }

		// UPS does not work with the plus 4 code on zip
    if (STORE_COUNTRY_CODE == 'US') $store_zip = substr(STORE_ORIGIN_ZIP, 0, 5);
    else $store_zip = STORE_ORIGIN_ZIP;
    
    // Check if Puerto Rico and set to PR instead of US country
    $dest_country = ($address_values['zone_id'] == 52) ? 'PR' : $address_values['country_code'];

    $request = array('accept_UPS_license_agreement' => 'yes',
    								 '10_action' => $action,
    								 '13_product' => $prod,
                     '14_origCountry' => STORE_COUNTRY_CODE,
                     '15_origPostal' => $store_zip,
                     '19_destPostal' => $dest_postal,
                     '22_destCountry' => $dest_country,
										 '23_weight' => $shipping_weight,
										 '47_rate_chart' => $rate,
										 '48_container' => $container,
										 '49_residential' => $residential);
    $result = trim(http_request("http://www.ups.com/using/services/rave/qcostcgi.cgi", $request));
    $body_array = @explode("\n", $result);

    $result_array = array();

    $n = sizeof($body_array);
    for ($i=0; $i<$n; $i++) {
      $result = explode('%', $body_array[$i]);
      $errcode = substr($result[0], -1);
      switch ($errcode) {
        case 3:
        case 4:
        	$result_array[$result[1]] = $result[10]; break;
        case 5:
        	$errorret = 'ERROR: ' . $result[1] . '<br />'; break;
        case 6:
        	$result_array[$result[3]] = $result[10]; break;
      }
    }
    
    if (!empty($result_array)) {
    	asort($result_array);
			$shipping_cost = 9999;
    	$products = $this->display();
			foreach ($result_array as $code => $rate) {
				if (constant('MODULE_SHIPPING_UPS_'.$code) == 'true') {
					$rate = $rate + ($rate * (SHIPPING_MARK/100));
					$rate = (SHIPPING_HANDLING_TOTAL + $rate) * $shipping_num_boxes;
					if ($rate < $shipping_cost) $shipping_cost = $rate;
					$this->quote[] = array('Method' => $products[$code], 'Service' => 'UPS ' . $products[$code], 'TotalCharges' => $rate);
				}
			}
			return $shipping_cost;
		}
		// no UPS quote so show a user defined message
		elseif (MODULE_SHIPPING_UPS_NOQUOTE != '') {
			$this->quote[] = array('Method' => MODULE_SHIPPING_UPS_NOQUOTE, 'Service' => @$errorret . MODULE_SHIPPING_UPS_NOQUOTE, 'TotalCharges' => '0.0');
			return '0.0';
		}
	}

	function display($code = false) {
  	$products = array('1DM' => 'Next Day Air Early AM',
										 '1DML' => 'Next Day Air Early AM Letter',
										 '1DA' => 'Next Day Air',
										 '1DAL' => 'Next Day Air Letter',
										 '1DAPI' => 'Next Day Air Intra (Puerto Rico)',
										 '1DP' => 'Next Day Air Saver',
										 '1DPL' => 'Next Day Air Saver Letter',
										 '2DM' => '2nd Day Air AM',
										 '2DML' => '2nd Day Air AM Letter',
										 '2DA' => '2nd Day Air',
										 '2DAL' => '2nd Day Air Letter',
										 '3DS' => '3 Day Select',
										 'GND' => 'Ground',
										 'GNDCOM' => 'Ground Commercial',
										 'GNDRES' => 'Ground Residential',
										 'STD' => 'Canada Standard',
										 'XPR' => 'Worldwide Express',
										 'XPRL' => 'Worldwide Express Letter',
										 'XDM' => 'Worldwide Express Plus',
										 'XDML' => 'Worldwide Express Plus Letter',
										 'XPD' => 'Worldwide Expedited',
										 'WXS' => 'Worldwide Saver',);
		if ($code) return $products[$code];
		return $products;
	}

	function check() {
	  return defined('MODULE_SHIPPING_UPS_STATUS');
	}

	function install() {
		$sort = 1;
		shop_db_perform('configuration', array('configuration_key'=>'MODULE_SHIPPING_UPS_STATUS','configuration_value'=>'true'), 'insert');
		shop_db_perform('configuration', array('configuration_title'=>'UPS Rate Quote Method', 'configuration_key'=>'MODULE_SHIPPING_UPS_CONT', 'configuration_value'=>'Customer Packaging', 'configuration_group_id'=>'6', 'sort_order'=>$sort++, 'set_function'=>'shop_cfg_select_option(array(\'Customer Packaging\', \'UPS Letter Envelope\', \'UPS Tube\', \'UPS Express Box\', \'UPS Worldwide 25 kilo\', \'UPS Worldwide 10 kilo\'),'), 'insert');
		shop_db_perform('configuration', array('configuration_title'=>'UPS Address Quote Method', 'configuration_key'=>'MODULE_SHIPPING_UPS_RESCOM', 'configuration_value'=>'Residential', 'configuration_group_id'=>'6', 'sort_order'=>$sort++, 'set_function'=>'shop_cfg_select_option(array(\'Commercial\', \'Residential\'),'), 'insert');
		shop_db_perform('configuration', array('configuration_title'=>'UPS Rate Quote Method', 'configuration_key'=>'MODULE_SHIPPING_UPS_RATE', 'configuration_value'=>'Regular Daily Pickup', 'configuration_group_id'=>'6', 'sort_order'=>$sort++, 'set_function'=>'shop_cfg_select_option(array(\'Regular Daily Pickup\', \'On Call Air\', \'One Time Pickup\', \'Letter Center\', \'Customer Counter\'),'), 'insert');
		shop_db_perform('configuration', array('configuration_title'=>'Enable UPS WorldShip Integration', 'configuration_key'=>'MODULE_SHIPPING_UPS_WORLDSHIP', 'configuration_value'=>'false', 'configuration_group_id'=>'6', 'sort_order'=>$sort++, 'use_function'=> 'shop_cfg_checkbox_display(', 'set_function'=>'shop_cfg_checkbox('), 'insert');
		shop_db_perform('configuration', array('configuration_title'=>'Notice if UPS Server is down?', 'configuration_key'=>'MODULE_SHIPPING_UPS_NOQUOTE', 'configuration_value'=>'A quote for shipping will be emailed to you', 'configuration_group_id'=>'6', 'sort_order'=>$sort++), 'insert');

		$products = $this->display();
		foreach ($products AS $code=>$name) {
			shop_db_perform('configuration', array('configuration_title'=>$name, 'configuration_key'=>'MODULE_SHIPPING_UPS_' . $code, 'configuration_value'=>'true', 'configuration_group_id'=>'6', 'sort_order'=>$sort++, 'use_function'=> 'shop_cfg_checkbox_display(', 'set_function'=>'shop_cfg_checkbox('), 'insert');
		}
	}

	function remove() {
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_SHIPPING_UPS_%'");
	}

	function keys() {
		$products = $this->display();
		$keys = array('MODULE_SHIPPING_UPS_STATUS', 'MODULE_SHIPPING_UPS_RESCOM', 'MODULE_SHIPPING_UPS_CONT', 'MODULE_SHIPPING_UPS_RATE', 'MODULE_SHIPPING_UPS_WORLDSHIP', 'MODULE_SHIPPING_UPS_NOQUOTE');
		foreach ($products AS $code=>$name) $keys[] = 'MODULE_SHIPPING_UPS_' . $code;
		return $keys;
	}
}